/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.schedule.action;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.NumberUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.AttendanceTotalAction;
import jp.mosp.kintai.common.part.LaborAgreementPart;
import jp.mosp.kintai.schedule.vo.ScheduleInputCardVo;

/**
 * @author yoshida
 *
 */
public class ScheduleInputCardAction extends AttendanceTotalAction {
	
	// コマンド
	private static final String	CMD_INPUT_CARD_SHOW		= "K1220";
	private static final String	CMD_INPUT_CARD_SELECT	= "K1221";
	private static final String	CMD_INPUT_CARD_REGIST	= "K1223";
	

	/**
	 * コンストラクタ
	 */
	public ScheduleInputCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_INPUT_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_INPUT_CARD_SELECT)) {
			// 選択
			select();
		} else if (cmd.equals(CMD_INPUT_CARD_REGIST)) {
			// 登録
			regist();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new ScheduleInputCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		ScheduleInputCardVo vo = (ScheduleInputCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// プルダウンのセット
		// 開始年月日のプルダウン
		vo.aryPltScheduleYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), 0, 1);
		vo.aryPltScheduleMonth = StringUtil.getMonthArray();
		vo.aryPltScheduleDay = StringUtil.getDayArray();
		// 日数プルダウンの配列
		vo.aryPltDays = StringUtil.getDayArray();
		/*						
		 *  	2008/11/14	m.yoshida	予定登録機能追加対応
		 */
		// 勤務形態
		vo.aryPltWorkType = part().worktype().getWorkTypeInfoArray();
		// 対象が無かった場合のメッセージ設定
		if (vo.aryPltWorkType.length == 0) {
			vo.setMessage(getMessage(MospConst.MSG_NO_DATA, ""));
		}
		// メニューボタン設定
		setScheduleMenuButton();
	}
	
	@Override
	protected void show() throws Exception {
		ScheduleInputCardVo vo = (ScheduleInputCardVo)getVo();
		// 対象年月取得
		Date todayDate = DateUtil.getSystemDate();
		// 対象年月日設定
		vo.setPltYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		vo.setPltScheduleDay(String.valueOf(MospUtility.getDay(todayDate)));
		// 対象日数設定
		vo.setPltRotationDays("1");
		/*						
		 *  	2008/11/14	m.yoshida	選択情報表示
		 */
		// 対象社員設定
		vo.setSelectKCode(userBasis.getKCode());
		// 選択情報の設定
		setLabelBasisInfo(userBasis);
		// 勤務パターンプルダウン
		vo.aryPltRotation = part().rotation().getRotationArray(vo.getSelectKCode());
	}
	
	@Override
	protected void select() throws Exception {
		ScheduleInputCardVo vo = (ScheduleInputCardVo)getVo();
		vo.setParams(request);
		// 対象年月取得
		Date todayDate = DateUtil.getSystemDate();
		// 対象年月日設定
		vo.setPltYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		vo.setPltScheduleDay(String.valueOf(MospUtility.getDay(todayDate)));
		// 対象日数設定
		vo.setPltRotationDays("1");
		/*						
		 *  	2008/11/14	m.yoshida	選択情報表示
		 */
		// 選択情報の設定
		setLabelBasisInfo(vo.getSelectKCode());
		// 勤務パターンプルダウン
		vo.aryPltRotation = part().rotation().getRotationArray(vo.getSelectKCode());
	}
	
	/**
	 * 登録処理
	 * @throws Exception	例外処理が発生した場合
	 */
	private void regist() throws Exception {
		ScheduleInputCardVo vo = (ScheduleInputCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		/*						
		 *  	2008/11/14	m.yoshida	予定登録機能追加対応
		 */
		// 開始日・終了日
		Date startDate;
		Date endDate;
		// 通常週休登録フラグ
		boolean isWeekHoliday = false;
		// 開始日・終了日設定
		if (StringUtil.isFlagOff(vo.getCkbSelectPeriod())) {
			/*						
			 *  	2009/01/20	m.yoshida	締め日対応
			 */
			Date targetDate = DateUtil.getFirstDateOfMonth(vo.getPltYear(), vo.getPltMonth());
			startDate = getStartDateForList(targetDate);
			endDate = getEndDateForList(targetDate);
			isWeekHoliday = true;
		} else {
			startDate = DateUtil.getDate(vo.getPltYear(), vo.getPltMonth(), vo.getPltScheduleDay());
			endDate = DateUtil.addDay(startDate, NumberUtil.getIntParam(vo.getPltRotationDays()) - 1);
		}
		// 輪番判断
		boolean isRotation = false;
		if (StringUtil.isFlagOn(vo.getCkbSelectWorkType())) {
			isRotation = true;
		}
		// 勤怠情報設定
		setCalcParam();
		// 更新・登録件数
		int number = registSchedule(vo.getSelectKCode(), makeScheduleMap(vo.getSelectKCode(), startDate, endDate, vo
			.getPltWorkTypeCode(), isRotation, vo.getPltRotationCode(), isWeekHoliday));
		// コミット
		commit();
		// 予定確認へ遷移
		setNextCmd(ScheduleConfirmListAction.CMD_CONFIRM_LIST_SEARCH);
		// メッセージ設定
		setMessage(getMessage(CommonConst.MSG_NUMBER_OF_UPDATES, String.valueOf(number)));
	}
	
	/**
	 * スケジュールMap生成
	 * @param kCode 			対象社員コード
	 * @param startDate			開始年月日
	 * @param endDate			終了年月日
	 * @param pltWorkTypeCode	対象勤務形態コード
	 * @param isRotation		輪番判断
	 * @param pltRotationCode	対象輪番パターンコード
	 * @param isWeekHoliday		週休判断
	 * @return 登録用スケジュールMap
	 * @throws Exception	例外処理が発生した場合
	 */
	private Map<Date, String> makeScheduleMap(String kCode, Date startDate, Date endDate, String pltWorkTypeCode,
			boolean isRotation, String pltRotationCode, boolean isWeekHoliday) throws Exception {
		Map<Date, String> scheduleMap = new HashMap<Date, String>();
		// データ数取得
		Calendar cal = Calendar.getInstance();
		cal.setTime(startDate);
		// 日数の設定
		int count = 0;
		while (endDate.compareTo(cal.getTime()) >= 0) {
			cal.add(Calendar.DAY_OF_MONTH, 1);
			count++;
		}
		/*						
		 *  	2008/11/14	m.yoshida	予定登録機能追加対応
		 */
		// 勤務パターンの勤務形態と祝祭日フラグを取得
		boolean isPublicHoliday = true;
		String[] aryRotation = new String[]{ pltWorkTypeCode };
		if (isRotation) {
			isPublicHoliday = part().rotation().getPublicHolidayFlag(pltRotationCode);
			aryRotation = part().rotation().getRotationInfoArray(kCode, pltRotationCode);
		}
		int irotate = 0;
		int max = aryRotation.length - 1;
		// 日付設定
		cal.setTime(startDate);
		// 労使協定情報取得
		setLaborAgreementInfo(kCode, startDate);
		for (int i = 0; i < count; i++) {
			if (irotate > max) {
				irotate = 0;
			}
			// 勤務パターンのローテーション
			while (StringUtil.isNull(aryRotation[irotate])) {
				irotate++;
				if (irotate > max) {
					irotate = 0;
				}
			}
			// 勤務形態コード
			String workTypeCode = aryRotation[irotate];
			// 輪番の場合
			if (isRotation) {
				// 祝祭日フラグ
				if (isPublicHoliday && part().jpholiday().isPublicHoliday(cal.getTime())) {
					workTypeCode = CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY;
				}
			} else {
				// 所定休日
				if (part().laborAgreement().isStandardHoliday(cal.getTime(), agreement)) {
					workTypeCode = CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY;
				}
				// 法定休日
				if (LaborAgreementPart.isOfficialHoliday(cal.getTime(), agreement)) {
					workTypeCode = CommonConst.ATTENDANCE_TYPE_OFFICIAL_HOLIDAY;
				}
			}
			scheduleMap.put(cal.getTime(), workTypeCode);
			irotate++;
			cal.add(Calendar.DAY_OF_MONTH, 1);
		}
		return scheduleMap;
	}
	
}
